#main windows
    def _update_ctrl(self):
        """ Contrôleur de mise de à jour de la liste des proxies dans le
        tableau
        """
        pu = dialogs.ProxiesUpdater(self)
        pf = ProxyFetcher()
        pf.started.connect(pu.show)
        pf.finished.connect(pu.hide)
        pf.new_proxies.connect(self._set_table)
        pf.start()

# threads.py
class ProxyFetcher(QtCore.QThread):
    """ Tâche recuperant les proxies disponibles sur l'ensemble des
    fournisseurs
    """

    new_proxies = QtCore.pyqtSignal(object)

    def __init__(self):
        QtCore.QThread.__init__(self)
        self._init_providers()

    def __del__(self):
        self.wait()

    def _init_providers(self):
        self._providers = []
        for name, cls in inspect.getmembers(providers):
            if inspect.isclass(cls) and cls.__module__ == "models.providers":
                self._providers.append(cls())

    def run(self):
        for provider in self._providers:
            self.new_proxies.emit(provider.get_proxies())

